﻿var interval = {
    selector: "",

    init: function (selector) {
        var self = this;
        this.selector = selector;

        //Creates html for iterval
        var intDiv = this.createHtml();

        //Copy html to each element
        var arr = $(selector);
        for (var i = 0; i < arr.length;i++)
        {
            var name = arr[i].getAttribute("data-name");
            var int = this.createHtml(name);
            arr[i].appendChild(int);
        }

        //Control if mouse is down
        $(document).mousedown(function () {
            self.mouseDown = true;
        }).mouseup(function () {
            self.mouseDown = false;
        });

        //Update when mouse click or move over sensor div
        $(".interval-wrapper .interval .sensor").mousemove(function (e) {
            //If mouse is down update
            if (self.mouseDown)
            {
                self.moveButtons(e, this);
            }
        });
        $(".interval-wrapper .interval .sensor").click(function (e) {
            self.moveButtons(e, this);
        });
    },

    moveButtons: function (e, element) {
        //Parent of interval created by user
        var grandParent = $(element).parents(this.selector);

        //Parent element created by script
        var parent = $(element).parent();
        var parentWidth = parseInt(parent.css("width"));

        //Cursor position in interval element
        var posX = e.pageX - $(element).offset().left;

        //Percent position of cursor
        var perc = (posX / parentWidth);

        //Get border values of interval
        var min = parseInt(grandParent.attr("data-min"));
        var max = parseInt(grandParent.attr("data-max"));
        //Value of current select
        var value = (min + (max - min) * perc);

        //Get buttons
        var buttonL = parent.find(".button:not(.right)");
        var buttonR = parent.find(".button.right");

        //Percent position of buttons from left
        var lButtonDistance = 1 - (parseInt(buttonL.css("right")) / parentWidth);
        var rButtonDistance = (parseInt(buttonR.css("left")) / parentWidth);

        //If is cursor closer to left button move with left button
        if(Math.abs(lButtonDistance - perc) < Math.abs(perc - rButtonDistance))
        {
            //But if cursor position is bigger than right button position move with right button
            if (perc > rButtonDistance)
            {
                this.updateMax(value, buttonR, perc, grandParent);
            }
            else
            {
                this.updateMin(value, buttonL, perc, grandParent);
            }
                
                
        }
        else
        {
            //If cursor position is smaller than left button position move with left button
            if (perc < lButtonDistance)
            {
                this.updateMin(value, buttonL, perc, grandParent);
            }
            else
            {
                this.updateMax(value, buttonR, perc, grandParent);
            }
        }
    },

    //Callbacks when values changes
    minChanged: function(min, parent){

    },
    maxChanged: function(max, parent){

    },

    //Update button position and call callbacks
    updateMin: function (min, minButton, minPerc, gParent) {
        minButton.css("right", (100 - minPerc * 100) + "%");
        this.minChanged(min, gParent);
    },

    updateMax: function (max, maxButton, maxPerc, gParent) {
        maxButton.css("left", (maxPerc * 100) + "%");
        this.maxChanged(max, gParent);
    },

    //Create html
    createHtml: function(name)
    {
        var d = document;
        //Interval input - create childs
        var intDiv = d.createElement("div");
        intDiv.setAttribute("class", "interval");

        var buttonContainer = d.createElement("div");
        buttonContainer.setAttribute("class", "button-container");
        
        var buttonLeft = d.createElement("div");
        buttonLeft.setAttribute("class", "button");

        var buttonRight = buttonLeft.cloneNode(true);
        buttonRight.setAttribute("class", "button right");

        var line = d.createElement("div");
        line.setAttribute("class", "line");

        var cLine = buttonLeft.cloneNode(true);
        cLine.setAttribute("class", "line colored");

        var sensor = d.createElement("div");
        sensor.setAttribute("class", "sensor");

        //Interval input - Add buttons to container
        buttonContainer.appendChild(buttonLeft.cloneNode(true));
        buttonContainer.appendChild(buttonRight.cloneNode(true));

        //Interval input - Put things together
        intDiv.appendChild(line.cloneNode(true));
        intDiv.appendChild(buttonContainer.cloneNode(true));
        intDiv.appendChild(sensor.cloneNode(true));
        

        //Interval input with textboxes
        var intWrap = d.createElement("div");
        intWrap.setAttribute("class", "interval-wrapper");

        //Interval - Put things together
        intWrap.appendChild(intDiv.cloneNode(true));

        return intWrap;
    },
}